function varargout = MSD(varargin)
% MSD M-file for MSD.fig
%      MSD, by itself, creates a new MSD or raises the existing
%      singleton*.
%
%      H = MSD returns the handle to a new MSD or the handle to
%      the existing singleton*.
%
%      MSD('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MSD.M with the given input arguments.
%
%      MSD('Property','Value',...) creates a new MSD or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before MSD_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to MSD_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help MSD

% Last Modified by GUIDE v2.5 01-May-2022 11:43:12

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @MSD_OpeningFcn, ...
                   'gui_OutputFcn',  @MSD_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before MSD is made visible.
function MSD_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to MSD (see VARARGIN)

% Choose default command line output for MSD
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes MSD wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = MSD_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
clear;
global T;
[filename,pathname]=uigetfile('*.xlsx','Select excel file containing 2 column for caculating MSD');
T=xlsread([pathname,filename]);

% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global im;
[filename,pathname]=uigetfile('*.tif','Select tif image for color show');
im=imread([pathname,filename]);

% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global T scal dt msd;
scal = str2num(get(handles.edit1,'string'));
dt = str2num(get(handles.edit2,'string'));
[row,col]=size(T);
N=row;
sumr=0;
msd=zeros(row,2);
for n=1:N-1;
    sumr=0;
    for i=1:N-n;
        r=(T(i+n,1)-T(i,1))^2+(T(i+n,2)-T(i,2))^2;
        sumr=sumr+r;
    end
    msd(n+1,2)=sumr/(N-n)*(scal^2);
    msd(n+1,1)=n*dt;
end
figure;
plot(msd(:,1),msd(:,2),'-o');
% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global im dt scal T;
[row,col]=size(T);
dc=jet(row);           % 18 colours are generated
figure;
imshow(im);
hold on                  % you much write this before the plot
for i=2:row;
    plot(T((i-1):i,1),T((i-1):i,2),'color',dc(i,:),'linewidth',2);   
end

hold off;
% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global msd;
[file_name,path_name]=uiputfile('*.xls','save msd caculation result', 't-msd.xlsx');
xlswrite(file_name,msd);


function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double


% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global T dt scal;
[row,col]=size(T);
vol=zeros(row,2);
dc=jet(row);           % 18 colours are generated   
for i=2:row;
    vol(i,1)=(i-1)*dt;
    vol(i,2)=sqrt((T(i,1)-T(i-1,1))^2+(T(i,2)-T(i-1,2))^2)*scal/dt; 
end

figure;
plot(vol(:,1),vol(:,2),'color','k','linewidth',2);
 hold on;
for j=1:row;
   
plot(vol(j,1),vol(j,2),'o','MarkerEdgeColor','k',...
                'MarkerFaceColor',dc(j,:),...
                'MarkerSize',10);
end
xlabel('Time (s)','fontsize',12,'fontweight','b');
ylabel('Velocity (m/s)','fontsize',12,'fontweight','b');
hold off;

figure;
hold on;
for m=2:row;
plot(vol(m-1:m,1),vol(m-1:m,2),'color',dc(m,:),'linewidth',2);
end
xlabel('Time (s)','fontsize',12,'fontweight','b');
ylabel('Velocity (m/s)','fontsize',12,'fontweight','b');
hold off;
